---
title: XRReferenceSpaceEvent.transform
slug: Web/API/XRReferenceSpaceEvent/transform
tags:
  - API
  - AR
  - Coordinate System
  - Coordinates
  - Event
  - Mixed
  - Orientation
  - Position
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRReferenceSpace
  - augmented
  - reset
  - transform
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRReferenceSpaceEvent")}} property <code><strong>transform</strong></code> indicates the position and orientation of the affected {{domxref("XRReferenceSpaceEvent.referenceSpace", "referenceSpace")}}'s native origin after the changes the event represents are applied.</span> The <code>transform</code> is defined using the old coordinate system, which allows it to be used to convert coordinates from the pre-event coordinate system to the post-event coordiante system.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>refSpace</em> = <em>xrReferenceSpaceEvent</em>.transform;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRRigidTransform")}} object providing a transform that can be used to convert coordinates from the pre-event coordinate system to the post-event coordinate system.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Upon receiving a <code>reset</code> event, you can apply the <code>transform</code> to cached position or orientation information to shift them into the updated coordinate system. Alternatively, you can just discard any cached positional information and recompute from scratch. The approach you take will depend on your needs.</p>

<p>For details on what causes a <code>reset</code> event and how to respond, see the {{domxref("XRReferenceSpaceEvent.reset_event", "reset")}} event's documentation.</p>

<h2 id="Examples">Examples</h2>

<p>This example handles the <code>reset</code> event by walking through all the objects in a scene, updating each object's position by multiplying it with the event's given <code>transform</code>. The scene is represented by a <code>scene</code> object, with all the objects in an array called <code>objects</code> within it.</p>

<pre class="brush: js">xrReferenceSpace.addEventListener("reset", event =&gt; {
  for (let obj of scene.objects) {
    mat4.multiply(obj.transform, obj.transform, event.transform);
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrreferencespaceevent-transform','XRReferenceSpaceEvent.transform')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRReferenceSpaceEvent.transform")}}</p>
